<?php 
/*
 Plugin Name: WordPress XML Export
 Plugin URI: http://www.technosailor.com
 Description: This will generate a WordPress XML export for import into other WordPress blogs. Based on code provided in 2.1+ versions of WordPress and originally written by <a href="http://www.photomatt.net">Matt Mullenweg</a>.
 Version: 2.0
 Author: Aaron Brazell
 Author URI: http://www.technosailor.com/
 */
 
		function export_wp($cats) 
			{
			global $wpdb, $posts, $post;
			$filename = 'wordpress.' . date('Y-m-d') . '.xml';
			header('Content-Description: File Transfer');
			header('Content-Type: application/octet-stream');
			header("Content-Disposition: attachment; filename=$filename");
			header('Content-type: text/xml; charset=' . get_settings('blog_charset'), true);
			
			// $posts = query_posts('');
			
			$cats = implode(',', $cats);

			
			$postswithcats = $wpdb->get_col("SELECT DISTINCT(post_id) FROM ".$table_prefix."post2cat WHERE category_id IN ($cats)");

			// print_r($postswithcats);

			
			$postcats = implode(',', $postswithcats);
			$posts = $wpdb->get_results("SELECT * FROM ".$table_prefix."posts WHERE ID IN ($postcats) ORDER BY post_date_gmt ASC");
?>
<!-- generator="wordpress/<?php bloginfo_rss('version') ?>" created="<?php echo date('Y-m-d H:m'); ?>"-->
<rss version="2.0" 
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:wfw="http://wellformedweb.org/CommentAPI/"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:wp="http://wordpress.org/export/1.0/"
>

<channel>
	<title><?php bloginfo_rss('name'); ?></title>
	<link><?php bloginfo_rss('url') ?></link>
	<description><?php bloginfo_rss("description") ?></description>
	<pubDate><?php echo mysql2date('D, d M Y H:i:s +0000', get_lastpostmodified('GMT'), false); ?></pubDate>
	<generator>http://wordpress.org/?v=<?php bloginfo_rss('version'); ?></generator>
	<language>fr</language>
	<?php do_action('rss2_head', false); ?>
<?php 
			if ($posts) 
				{ foreach ($posts as $post) 
					{ start_wp(); // print_r($post); ?>
<item>
<title><?php the_title_rss() ?></title>
<link><?php permalink_single_rss() ?></link>
<pubDate><?php echo mysql2date('D, d M Y H:i:s +0000', $post->post_date, false); ?></pubDate>
<dc:creator><?php the_author() ?></dc:creator>
<?php the_category_rss() ?>

<guid isPermaLink="false"><?php permalink_single_rss() ?></guid>
<description></description>
<wp:excerpt><![CDATA[<?php echo $post->post_excerpt ?>]]></wp:excerpt>
<content:encoded><![CDATA[<?php echo $post->post_content ?>]]></content:encoded>
<wp:post_date><?php echo $post->post_date; ?></wp:post_date>
<wp:post_date_gmt><?php echo $post->post_date_gmt; ?></wp:post_date_gmt>
<wp:comment_status><?php echo $post->comment_status; ?></wp:comment_status>
<wp:ping_status><?php echo $post->ping_status; ?></wp:ping_status>
<wp:post_name><?php echo $post->post_name; ?></wp:post_name>
<wp:status><?php echo $post->post_status; ?></wp:status>
<wp:post_parent><?php echo $post->post_parent; ?></wp:post_parent>
<wp:post_type><?php echo $post->post_type; ?></wp:post_type>
<?php
		$postmeta = $wpdb->get_results("SELECT * FROM ".$table_prefix."postmeta WHERE post_id = $post->ID"); 
					if ( $postmeta ) 
						{
?>
<?php 
						foreach( $postmeta as $meta ) 
							{ 
?>	
<wp:postmeta>
<wp:meta_key><?php echo $meta->meta_key; ?></wp:meta_key>
<wp:meta_value><?Php echo $meta->meta_value; ?></wp:meta_value>
</wp:postmeta>
<?php 						} 
						} 
					$comments = $wpdb->get_results("SELECT * FROM ".$table_prefix."comments WHERE comment_post_ID = $post->ID"); 
					if ( $comments ) { foreach ( $comments as $c ) 
						{ 
?>
<wp:comment>
<wp:comment_author><?php echo htmlent2numeric($c->comment_author); ?></wp:comment_author>
<wp:comment_author_email><?php echo $c->comment_author_email; ?></wp:comment_author_email>
<wp:comment_author_url><?php echo $c->comment_author_url; ?></wp:comment_author_url>
<wp:comment_author_IP><?php echo $c->comment_author_IP; ?></wp:comment_author_IP>
<wp:comment_date><?php echo $c->comment_date; ?></wp:comment_date>
<wp:comment_date_gmt><?php echo $c->comment_date_gmt; ?></wp:comment_date_gmt>
<wp:comment_content><?php echo htmlent2numeric($c->comment_content); ?></wp:comment_content>
<wp:comment_approved><?php echo $c->comment_approved; ?></wp:comment_approved>
<wp:comment_type><?php echo $c->comment_type; ?></wp:comment_type>
<wp:comment_parent><?php echo $c->comment_parent; ?></wp:comment_parent>
</wp:comment>
<?php 					} 
					} 
?>
	</item>
<?php 
				} 
			} 
?>
</channel>
</rss>
<?php
exit;
wp_redirect('admin.php');
		}

		function htmlent2numeric($string)
		{
			$conversion = array(
			'&amp;' => '&#38;',
			'&raquo;' => '&#187;',
			'&endash;' => '&#8211;',
			'&emdash;' => '&#8212;',
			'&quot;' => '&#34;',
			'&' => '&#38;'
			);
			
			foreach($conversion as $oldchar => $newchar)
				$string = str_replace($oldchar, $newchar, $string);
			return $string;
		}

		function export_cat_list()
		{
			global $wpdb;
			$cats = $wpdb->get_results("SELECT cat_ID, cat_name, category_nicename, category_description, category_parent, category_count
                        FROM ".$table_prefix."categories
                        WHERE cat_ID > 0 
                        ORDER BY cat_name");
			return $cats;
		}
?>